// O kralovskych daroch
// Autor: Peter Trebaticky
//
// Na prelozenie n kufrov z jedneho voza na iny treba (2^n)-1 presunov.
// i-ty voz pojde do i-teho kralovstva. Preto voz, ktory prisiel z pokladnice,
// bude mat cislo najspodnejsieho kufra.
// 'Neprelozeny kufor' znamena, ze ho treba este aspon raz premiestnit.
// Vsetky kufre su v poli 'kufre' - kufre[0] je najspodnejsi kufor.
// Premenna 'voz' oznacuje cislo vozu, na ktorom su neprelozene kufre.
// Premenna 'indx' ukazuje na najspodnejsi neprelozeny kufor.
// Opis algoritmu:
//  Vzdy treba prelozit prvy najspodnejsi neprelozeny kufor, ktory sa
//  nezhoduje s cislom vozu, na ktorom sa nachadza, na voz s cislom tohto
//  kufra. Cize treba prelozit vsetky kufre nad tymto kufrom na nevyuzity voz
//  ((2^n)-1 presunov) + tento kufor (1 presun). Takze 2^n presunov.
//  Minimalny pocet presunov je teda suctom tychto ciastkovych presunov.
#include <stdio.h>

#define NOdebug

#define MAX 30
int tab[4][4]=    // ak este neprelozene kufre su na i-tom voze
    {{0,0,0,0},   // a najspodnejsi kufor je pre j-te kralovstvo,
     {0,0,3,2},   // potom treba premiestnit vsetky este neprelozene kufre
     {0,3,0,1},   // okrem najspodnejsieho na voz cislo tab[i][j]
     {0,2,1,0}};

FILE *fin,*fout;
int kufre[MAX];
int indx,n,voz,pocobj;
unsigned long int i,j,vysl;

void main(void)
{
#ifdef debug
  fin=fopen("gifts.in","rt");
  fout=fopen("gifts.out","wt");
#else
  fin=stdin;
  fout=stdout;
#endif

  fscanf(fin,"%d",&pocobj);

  for(j=0;j<pocobj;j++){
    indx=0;vysl=0;
    fscanf(fin,"%d",&n);
    for(i=0;i<n;i++) fscanf(fin,"%d",&kufre[i]);
    kufre[n]=0;

    voz=kufre[0];
    while(indx<n){
      while(kufre[indx]==voz)indx++;
      voz=tab[voz][kufre[indx]];
      indx++;
      if(indx<=n)
        vysl+=((unsigned long int)1) << (n-indx);// 2^(n-indx)
    }
    fprintf(fout,"%lu\n",vysl);
  }

#ifdef debug
  fclose(fin);
  fclose(fout);
#endif
}
